{
  site.net.flpk = {
    domainName = "flpk.zentralwerk.org";
    subnet4 = "45.158.40.160/27";
    # we get a /56
    subnets6.flpk = "2a0f:5382:acab:1400::/64";
    hosts4 = {
      flpk-gw = "45.158.40.161";
      leon = "45.158.40.162";
    };
    hosts6.flpk = {
      flpk-gw = "2a0f:5382:acab:1400::c3d2";
      leon = "2a0f:5382:acab:1400::1e0";
    };
  };

  site.hosts.flpk-gw = {
    interfaces = {
      core = {
        hwaddr = "0A:14:48:b7:e4:91";
        type = "veth";
      };
      flpk = {
        hwaddr = "0A:14:48:01:16:01";
        type = "veth";
      };
      up-flpk = {
        type = "wireguard";
        upstream = {
          provider = "flpk";
          noNat = {
            subnets4 = [ "45.158.40.160/27" ];
            subnets6 = [ "2a0f:5382:acab:1400::/56" ];
          };
        };
      };
    };
    ospf = {
      allowedUpstreams = [ "upstream4" "upstream3" "freifunk" ];
      upstreamInstance = 2;
    };
    role = "container";
  };
}
